<script setup lang="ts">
import { onMounted, Ref, ref, toRefs, watch } from 'vue';
import { IDataProviderResponse } from '../../code/interfaces/IDataProvider';
import BasicTextCardContextMenu from './ContextMenuVariants/BasicTextCardContextMenu.vue';
import FallbackErrorContextMenu from './ContextMenuVariants/FallbackErrorContextMenu.vue';
import RoomMetricsContextMenu from './ContextMenuVariants/RoomMetricsContextMenu.vue';
const props = defineProps({
    isShown : Boolean,
    path: {
        type: Array,
        required: true
    }
});
const {isShown} = toRefs(props)

const dataProvider = import("../../code/dataproviders/MockDataProvider");
// Data Provider Refs
const isLoading = ref(false);
const recentProviderData = ref({}) as Ref<IDataProviderResponse>

const updateContextData = async(newPath: string[]) => {

	isLoading.value = true;
	let response : IDataProviderResponse | undefined;
	try {
		response = await (await dataProvider).SingletonInstance.getDataForNode(newPath)
	}
	catch {
		response = {
			"responseStructure": "error",
			"payload": {}
		} as IDataProviderResponse
	}
	finally {
		if(typeof response === "undefined") {
			throw new Error("Response is undefined. Should never happen.")
		}
		recentProviderData.value = response
		isLoading.value = false;
	}
}


watch(() => props.path as string[], async (newVal: string[], oldVal: string[]) => {
	if(newVal.join(".") === oldVal.join(".")) {
		return;
	}
	updateContextData(newVal)

});

onMounted( () => {
	updateContextData((props.path ?? []) as string[])
})

</script>

<template>
<QDialog v-model="isShown" seamless position="right">
    <QCard class="mainCard">
		<!-- Loading -->
		<div v-if="isLoading && true"> <!-- Doesnt look good. And with quick speeds not needed -->
			<QItem>
				<QItemSection>
					<QItemLabel caption>
						<QSkeleton type="text"></QSkeleton>
					</QItemLabel>
				</QItemSection>
			</QItem>
			<QSkeleton height="150px" square></QSkeleton>
		</div>
		<div v-else>
			<BasicTextCardContextMenu v-if="recentProviderData.responseStructure === 'basic'"
				:body="recentProviderData?.payload?.body ?? ''"
				:heading="recentProviderData?.payload?.heading ?? ''"  />
			<RoomMetricsContextMenu v-else-if="recentProviderData.responseStructure === 'metrics'"
				:heading="recentProviderData?.payload?.heading ?? ''"
				:humidity-fraction="recentProviderData?.payload?.humidityFraction"
				:temperature-deg="recentProviderData?.payload?.temperatureDeg" />
			<FallbackErrorContextMenu v-else :path="path"/>
		</div>

    </QCard>
</QDialog>
</template>

<style scoped lang="scss">
.mainCard {
    width: 400px;
}
</style>
